#!/usr/bin/perl

my $PACKAGE_PATH = $ENV{"PACKAGE_PATH"};

$PACKAGE_PATH or die "Couldn't figure out where the package lives.";

my $options = {
  blog_name => qq{my $blog_title = "My Blosxom";},
  blog_description => qq{my $blog_description = "Yet another Blosxom blog.";},
  num_entries => qq{my $num_entries = 40;},
  blog_language => qq{my $blog_language = "en";},
  url => qq{my $url = "";}
};

print "... reading out-of-the-box blosxom.cgi\n";
open IN, "$PACKAGE_PATH/Contents/Resources/blosxom.cgi" or die "couldn't open $PACKAGE_PATH/Contents/Resources/blosxom.cgi for reading: $!\n";
my $blosxom = join '', <IN>;
close IN;

print "... prompting for answers to configuration questions\n";
my $options = `/usr/bin/osascript $PACKAGE_PATH/Contents/Resources/configure.scpt 2>&1`;
chomp $options;

$options =~ /User canceled/ and exit;

my $changes = 0;
foreach ( split /\$\$\$/, $options ) {
  my($k, $v) = split /=/, $_;
  next unless $k and $v;
  $blosxom =~ s!^my \$$k = (qq{|")?.+?["}]?;$!my \$$k = qq{$v};!mg;
  $changes++;
}

if ($changes) { 
  print "... writing changes to blosxom.cgi\n";
  open OUT, "> $PACKAGE_PATH/Contents/Resources/blosxom.cgi";
  print OUT $blosxom;
  close OUT;
}
